
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>线程基础：JDK1.5+（10）——线程新特性（下） / 憋错料</title>

    <meta name="description" content="线程基础：JDK1.5+（10）——线程新特性（下） (接上文&lt;线程基础:JDK1.5+(9)--线程新特性(中)&gt;) 3-4.CountDownLatch:同步器 上文中我们主要讲解了JDK1.5+中提供的一个重要工具:Semaphore信号量,并且用这个工具第一次实现了&quot;100米赛跑&quot;的需求.在第一次的实现中,我们还运用了&quot;线程专栏&quot;中已介绍的多个知识点,包括锁.线程池.队列.Callable接口等. 但实际上第一次实现的&quot;100米赛跑&quot;的需求,离我们真正的需求还有一定的距 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">线程基础：JDK1.5+（10）——线程新特性（下）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>（接上文《<a href="http://blog.csdn.net/yinwenjie/article/details/50659540" rel="external nofollow noreferrer">线程基础：JDK1.5+（9）——线程新特性（中</a>）》）</p>
<h2>3-4、CountDownLatch：同步器</h2>
<p>上文中我们主要讲解了JDK1.5+中提供的一个重要工具：Semaphore信号量，并且用这个工具第一次实现了“100米赛跑”的需求。在第一次的实现中，我们还运用了“线程专栏”中已介绍的多个知识点，包括锁、线程池、队列、Callable接口等。</p>
<p>但实际上第一次实现的“100米赛跑”的需求，离我们真正的需求还有一定的距离：<strong>在我们第一次实现时，选手是否可以跑步，完全取决于“是否有空闲的赛道”。但是原始需求中特别要求对所有的选手进行分组</strong>。特别是初赛时（因为决赛时就只有一组了）：<strong>最多5名选手一组，每组选手需要一起进行跑步</strong>。</p>
<p>也就是说，选手是否可以跑步，不但取决于是否有空闲的赛道，还取决于当前选手所属组的其他选手的准备情况。<strong>只有当跑道有空余，并且该组其它选手也准备完毕，才能一起开始跑步</strong>（这样才能称为赛跑嘛）。</p>
<p>在JKD1.5+环境中，Doug Lea和他的团队为我们提供了可以很好实现这个要求的工具类：CountDownLatch和CyclicBarrier。我们首先介绍CountDownLatch的基本使用方式：</p>
<h3>3-4-1、CountDownLatch基本使用</h3>
<p>CountDownLatch是一个同步计数器，能够保证在其他线程完成某一个业务操作前，当前线程一直处于等待/阻塞状态。具体来说，这个计数器将会从给定的某一个数值count开始，通过countDown()方法的调用进行倒数。当执行某一次countDown()操作后，计数器的count数值等于0，所有调用了await()方法的线程，就解除等待/阻塞状态继续执行。我们来看一段简单的示例代码：</p>
<pre><code>package test.thread.countDownLatch;

import java.util.concurrent.CountDownLatch;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.log4j.BasicConfigurator;

public class TestCountDownLatch {
    /**
     * 日志
     */
    private static Log LOGGER = LogFactory.getLog(TestCountDownLatch.class);

    static {
        BasicConfigurator.configure();
    }

    public static void main(String[] args) throws Throwable {
        // 同步计数器从5开始计数
        final CountDownLatch countDownLatch = new CountDownLatch(5);

        // 启动子线程，处理“其他”业务
        for(int index = 0 ; index &lt; 5 ; index++) {
            Thread childThread = new Thread() {
                @Override
                public void run() {
                    //等待，以便模型业务处理过程消耗的时间
                    synchronized (this) {
                        try {
                            this.wait(1000);
                        } catch (InterruptedException e) {
                            TestCountDownLatch.LOGGER.error(e.getMessage(), e);
                        }
                    }

                    // 完成业务处理过程，计数器-1
                    long threadid = Thread.currentThread().getId();
                    TestCountDownLatch.LOGGER.info("子线程(" + threadid + ")执行完成！");
                    countDownLatch.countDown();
                }
            };
            childThread.start();
        }

        // 等待所有子线程的业务都处理完成（计数器的count为0时）
        countDownLatch.await();
        TestCountDownLatch.LOGGER.info("所有子线程的处理都完了，主线程继续执行...");
    }
}
</code></pre>
<p>以下是可能的执行结果（因为每次执行的效果可能有所区别）：</p>
<pre><code>1 [Thread-3] INFO test.thread.countDownLatch.TestCountDownLatch  - 子线程(12)执行完成！
1 [Thread-4] INFO test.thread.countDownLatch.TestCountDownLatch  - 子线程(13)执行完成！
1 [Thread-1] INFO test.thread.countDownLatch.TestCountDownLatch  - 子线程(10)执行完成！
1 [Thread-2] INFO test.thread.countDownLatch.TestCountDownLatch  - 子线程(11)执行完成！
1 [Thread-0] INFO test.thread.countDownLatch.TestCountDownLatch  - 子线程(9)执行完成！
9 [main] INFO test.thread.countDownLatch.TestCountDownLatch  - 所有子线程的处理都完了，主线程继续执行...</code></pre>
<p>以上代码片段和执行结果说明了CountDownLatch的最简单使用，CountDownLatch同步计数器从5开始计数，分别对应5个子线程的业务完成情况。每当一个子线程业务完成后，CountDownLatch同步计数器就countDown一次。直到count等于0时，这时主线程上面的await()方法解除等待/阻塞状态，继续执行。这里要注意一下：</p>
<ul>
<li>不是说只能有一次await方法的调用，<strong>而是同一时间可以有多个线程调用了await方法</strong>。只要在count还不等于0时，某个线程调用了await方法，它都会进入等待/阻塞状态。</li>
<li>在调用await时，如果CountDownLatch同步计数器的count已经等于0了，则await方法不会进入等待/阻塞状态。</li>
<li>await调用和countDown调用不是说必须处于不同线程。同一线程中，您可以先调用countDown然后再调用await进入等待/阻塞。CountDownLatch同步计数器会始终遵循上两条工作原则。</li>
<li>在使用CountDownLatch同步计数器时，您无需考虑脏数据的问题。CountDownLatch同步计数器是线程安全的。</li>
</ul>
<h3>3-4-2、CountDownLatch在“100米赛跑”中的应用</h3>
<p>很明显CountDownLatch在“100米赛跑”中的使用目标是：“等待这组所有的选手全部上跑道”，然后一起开始跑步。所以，CountDownLatch的计数器，需要在选手获得“跑道”资源后，马上countDown一次。之后，获得“跑道”资源的选手要立刻调用await进入等待状态，等待其他选手也获得跑道资源。我们给这整个处理逻辑去一个名字叫做：“发令枪”，代码片段如下：</p>
<pre><code>......
/**
 * 选手所关注的发令枪
 */
private CountDownLatch startingGun;
......

public Result call() throws Exception {
    ......
    try {
        // 申请上跑道（这个没有变化）
        this.runway.acquire();
        // 等待可能的发令枪
        if(this.startingGun != null) {
            // 执行到这里，说明这个选手已经拿到了跑到资源；
            // 向发令枪表达“我已准备好”，即计数器-1
            this.startingGun.countDown();
            System.out.println("选手" + name + "[" + number + "]，已登上跑道，等待发令！");
            // 接下来进入“等待”状态
            // 以便等这个发令枪所管理的所有选手上跑道了，再一起跑步
            this.startingGun.await();
            System.out.println("选手" + name + "[" + number + "]，跑！");
        }

        // 开始正式跑步
        return this.result = this.doRun();
    } catch(Exception e) {
        e.printStackTrace(System.out);
    } finally {
        // 都要进入初赛结果排序（中途退赛的成绩就为0）
        this.runway.release();
        System.out.println("选手" + name + "[" + number + "]，比赛正常完成！");
    }
    ......
}
......</code></pre>
<p>那么如何进行分组呢？我们可以让一组选手，关注同一把“发令枪”（有多少把发令枪，就有多少个组、就有多少个CountDownLatch对象）。如下图所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjAyMTcxMDU1NDc0Mjk=.jpg"></p>
<p>另外，分组时一定要考虑一个问题：<strong>由于报名人数不一定是5的整数倍，所以最后一组不一定有5个人</strong>。考虑到实现的代码片段如下：</p>
<pre><code>......
// 这是发令枪
CountDownLatch startingGun = null;
......
// signupPlayers 是报名队列
// runwayCount 是跑道数量
for (int index = 0 ; index &lt; this.signupPlayers.size() ; index++) {
    /*
     * 这是发令枪，发令枪的使用规则是：
     * 1、最多5位选手听从一把发令枪的命令（因为跑道最多就是5条）
     * 2、如果剩余的没有比赛的选手不足5人，则这些人听从一把发令枪的命令
     * */
    if(index % runwayCount == 0) {
        startingGun =  this.signupPlayers.size() - index &gt; runwayCount?
            new CountDownLatch(runwayCount):
            new CountDownLatch(this.signupPlayers.size() - index);
    }

    // 获取这个选手（signupPlayers是报名队列）
    Player player = this.signupPlayers.get(index);
    // 设置选手关注的发令枪
    player.setStartingGun(startingGun);
    // 提交给裁判组协调执行
    Future&lt;Result&gt; future = refereeService.submit(player);

    // 开始一个选手的跑步动作状态监控
    new FutureThread(future, player, this.preliminaries).start();
}
......</code></pre>
<p>这样我们就完成了对第一次“100米赛跑”实现代码的优化：增加了选手分组控制功能。以下给出相对完整的代码。注意，由于Result类没有做任何更改，所以就不需要赘述了。</p>
<ul>
<li>Player选手类的的更改，主要是加入了“关注的发令枪”的关注</li>
</ul>
<pre><code>public class Player implements Callable&lt;Result&gt; , Comparable&lt;Player&gt;{
    ......
    /**
     * 跑道
     */
    private Semaphore runway;

    /**
     * 选手所关注的发令枪
     */
    private CountDownLatch startingGun;
    ......

    /**
     * @param startingGun the startingGun to set
     */
    public void setStartingGun(CountDownLatch startingGun) {
        this.startingGun = startingGun;
    }

    /**
     * @return the startingGun
     */
    public CountDownLatch getStartingGun() {
        return startingGun;
    }

    ......
    /* (non-Javadoc)
     * @see java.util.concurrent.Callable#call()
     */
    @Override
    public Result call() throws Exception {
        this.result = null;
        try {
            // 申请上跑道
            this.runway.acquire();
            // 等待可能的发令枪
            if(this.startingGun != null) {
                // 执行到这里，说明这个选手已经拿到了跑到资源；
                // 首先向发令枪表达“我已准备好”，即计数器-1
                this.startingGun.countDown();
                System.out.println("选手" + name + "[" + number + "]，已登上跑道，等待发令枪！");
                // 接下来进入“等待”状态
                // 以便这个发令枪所管理的所有选手登上跑道了，再一起跑步
                this.startingGun.await();
                System.out.println("选手" + name + "[" + number + "]，跑！");
            }

            // 开始正式跑步
            return this.result = this.doRun();
        } catch(Exception e) {
            e.printStackTrace(System.out);
        } finally {
            // 都要进入初赛结果排序（中途退赛的成绩就为0）
            this.runway.release();
            System.out.println("选手" + name + "[" + number + "]，比赛正常完成！");
        }

        // 如果执行到这里，说明异常发生了
        this.result = new Result(Float.MAX_VALUE);
        return this.result;
    }

    /**
     * 开始跑步(跑步的处理过程没有变化)
     * @return
     * @throws Exception
     */
    private Result doRun()  throws Exception {
        /*
         * 为了表现一个选手每一次跑步都有不同的状态（但是都不会低于其最低状态），
         * 所以每一次跑步，系统都会为这个选手分配一个即时速度。
         *
         * 这个即时速度不会低于其最小速度，但是也不会高于 14米/秒(否则就是‘超人’咯)
         * */
        // 生成即时速度
        float presentSpeed = 0f;
        presentSpeed = this.minSpeed * (1.0f + new Random().nextFloat());
        if(presentSpeed &gt; 14f) {
            presentSpeed = 14f;
        }

        // 计算跑步结果(BigDecimal的使用可自行查阅资料)
        BigDecimal calculation =  new BigDecimal(100).divide(new BigDecimal(presentSpeed) , 3, RoundingMode.HALF_UP);
        float presentTime = calculation.floatValue();

        // 让线程等待presentSpeed的时间，模拟该选手跑步的过程
        synchronized (this) {
            this.wait((long)(presentTime * 1000f));
        }

        // 返回跑步结果
        this.result = new Result(presentTime);
        return result;
    }

    ......
}</code></pre>
<ul>
<li>TwoTrack比赛主控制类，主要加入了对“选手分组”的支持</li>
</ul>
<pre><code>/**
 * 这是第二个比赛程序。
 * @author yinwenjie
 *
 */
public class TwoTrack {
    ......
    public void track() {
        /*
         * 赛跑分为以下几个阶段进行；
         *
         * 1、报名
         * 2、初赛，11名选手，分成两组，每组最多5名选手。
         * 因为场地只有5条赛道，只有拿到进场许可的才能使用赛道，进行比赛
         *
         * 3、决赛：初赛结果将被写入到一个队列中进行排序，只有成绩最好的前五名选手，可以参加决赛。
         *
         * 4、决赛结果的前三名将分别作为冠亚季军被公布出来
         * */

        //1、================报名
        // 这就是跑道，需求上说了只有5条跑道，所以只有5个permits。
        Semaphore runway = new Semaphore(5);
        this.signupPlayers.clear();
        for(int index = 0 ; index &lt; TwoTrack.PLAYERNAMES.length ; ) {
            Player player = new Player(TwoTrack.PLAYERNAMES[index], ++index , runway);
            this.signupPlayers.add(player);
        }

        //2、================进行初赛
        // 这是赛道的数量
        int runwayCount = 5;
        // 这是裁判
        ExecutorService refereeService = Executors.newFixedThreadPool(5);
        // 这是发令枪
        CountDownLatch startingGun = null;
        for (int index = 0 ; index &lt; this.signupPlayers.size() ; index++) {
            /*
             * 这是发令枪，发令枪的使用规则是：
             * 1、最多5位选手听从一把发令枪的命令（因为跑道最多就是5条）
             * 2、如果剩余的没有比赛的选手不足5人，则这些人听从一把发令枪的命令
             * */
            if(index % runwayCount == 0) {
                startingGun =  this.signupPlayers.size() - index &gt; runwayCount?
                    new CountDownLatch(runwayCount):
                    new CountDownLatch(this.signupPlayers.size() - index);
            }

            // 获取这个选手
            Player player = this.signupPlayers.get(index);
            // 设置选手关注的发令枪
            player.setStartingGun(startingGun);
            // 提交给裁判组准备执行
            Future&lt;Result&gt; future = refereeService.submit(player);

            // 开始一个选手的跑步动作状态监控
            new FutureThread(future, player, this.preliminaries).start();
        }
        //! 只有当PLAYERNAMES.length位选手的成绩都产生了，才能进入决赛，这很重要
        while(this.preliminaries.size() &lt; TwoTrack.PLAYERNAMES.length) {
            try {
                synchronized (this.preliminaries) {
                    this.preliminaries.wait();
                }
            } catch(InterruptedException e) {
                e.printStackTrace(System.out);
            }
        }

        // 3、============决赛(只有初赛结果的前5名可以参见)
        // 决赛的发令枪
        startingGun = new CountDownLatch(5);
        for(int index = 0 ; index &lt; 5 ; index++) {
            Player player = this.preliminaries.poll();
            // 重新设置选手关注的发令枪
            player.setStartingGun(startingGun);
            // 提交给裁判组准备执行
            Future&lt;Result&gt; future = refereeService.submit(player);

            // 开始一个选手的跑步动作状态监控
            new FutureThread(future, player, this.finals).start();
        }
        //! 只有当5位选手的决赛成绩都产生了，才能到下一步：公布成绩
        while(this.finals.size() &lt; 5) {
            try {
                synchronized (this.finals) {
                    this.finals.wait();
                }
            } catch(InterruptedException e) {
                e.printStackTrace(System.out);
            }
        }

        // 4、============公布决赛成绩（前三名）
        for(int index = 0 ; index &lt; 3 ; index++) {
            Player player = this.finals.poll();
            switch (index) {
            case 0:
                System.out.println("第一名："  + player.getName() + "[" + player.getNumber() + "]，成绩：" + player.getResult().getTime() + "秒");
                break;
            case 1:
                System.out.println("第二名："  + player.getName() + "[" + player.getNumber() + "]，成绩：" + player.getResult().getTime() + "秒");
                break;
            case 2:
                System.out.println("第三名："  + player.getName() + "[" + player.getNumber() + "]，成绩：" + player.getResult().getTime() + "秒");
                break;
            default:
                break;
            }
        }
    }

    ......
    //其他诸如FutureThread、main函数的代码都没有变化
}</code></pre>
<h3>3-4-3、相似工具类CyclicBarrier</h3>
<p>在JDK1.5+中还有一个和CountDownLatch类似的同步计数工具：CyclicBarrier。不同的是CyclicBarrier的计数是循环进行的，而且也不需要向CountDownLatch那样显示的调用countDown进行减一操作。</p>
<p>如何理解CyclicBarrier计数器的循环工作方式呢？我们先来看看一个比较简单的示例代码：</p>
<pre><code>public class TestCyclicBarrier {

    static {
        BasicConfigurator.configure();
    }

    /**
     * 日志
     */
    private static Log LOGGER = LogFactory.getLog(TestCyclicBarrier.class);

    public static void main(String[] args) throws Throwable {
        // 同步计数器的技术周期为3
        final CyclicBarrier cyclicBarrier = new CyclicBarrier(3);

        // 启动子线程，处理“其他”业务
        for(int index = 0 ; index &lt; 5 ; index++) {
            Thread childThread = new Thread() {
                @Override
                public void run() {
                    // 可获得设置的屏障数值
                    // int parties = cyclicBarrier.getParties();
                    // 可获取当前已经进入等待状态的任务数量
                    // int numberWaiting = cyclicBarrier.getNumberWaiting();
                    TestCyclicBarrier.LOGGER.info("本线程已准备好处理业务......");
                    try {
                        cyclicBarrier.await();
                    } catch (InterruptedException | BrokenBarrierException e) {
                        TestCyclicBarrier.LOGGER.error(e.getMessage() , e);
                    }
                    TestCyclicBarrier.LOGGER.info("开始处理业务......");
                }
            };
            childThread.start();
        }
    }
}</code></pre>
<p>我们可以用下图表示以上代码的工作过程：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjAyMTcxNTEyNDU0MzA=.jpg"></p>
<p>在上图中，CyclicBarrier的parties屏障设置为3，其意义是只要有通过CyclicBarrier的await方法进入阻塞等待的线程数量达到了3，则CyclicBarrier就解除这些线程的阻塞状态让他们可以继续执行。所以可以理解为CyclicBarrier的计数功能是可重复使用的，<strong>当等待的线程数量达到了设置的屏障值就放行这些线程</strong>。</p>
<h3>3-4-4、使用CyclicBarrier改写“比赛”</h3>
<p>下面我们将“比赛”中使用CountDownLatch实现的发令枪改写成使用CyclicBarrier来实现。改写发令枪不会使发令枪的工作职责发生任何变化，所以改写量是比较小的。另外由于这个小节中我们已经给出了很多代码了，为了节约篇幅这里只给出最小化的代码片段。</p>
<ul>
<li>Player选手类中，关于发令枪的定义要修改：</li>
</ul>
<pre><code>......
/**
 * 选手所关注的发令枪
 */
private CyclicBarrier startingGun;

/**
 * @param startingGun the startingGun to set
 */
public void setStartingGun(CyclicBarrier startingGun) {
    this.startingGun = startingGun;
}

/**
 * @return the startingGun
 */
public CyclicBarrier getStartingGun() {
    return startingGun;
}
......</code></pre>
<ul>
<li>Player选手类中的发令枪使用部分需要改写。使用CyclicBarrier后就不需要显示调用countDown()方法了：</li>
</ul>
<pre><code>......
// 申请上跑道
this.runway.acquire();
// 等待可能的发令枪
if(this.startingGun != null) {
    // 执行到这里，说明这个选手已经拿到了跑到资源；
    System.out.println("选手" + name + "[" + number + "]，已登上跑道，等待发令枪！");
    // 接下来进入“等待”状态
    // 以便这个发令枪所管理的所有选手登上跑道了，再一起跑步
    this.startingGun.await();
    System.out.println("选手" + name + "[" + number + "]，跑！");
}

// 开始正式跑步
return this.result = this.doRun();
......</code></pre>
<ul>
<li>TwoTrack主操作类中，关于发令枪的定义要进行变更：从CountDownLatch变成CyclicBarrier：</li>
</ul>
<pre><code>......
// 这是发令枪
CyclicBarrier startingGun = null;
......</code></pre>
<ul>
<li>TwoTrack主操作类中，根据条件决定CyclicBarrier中parties屏障值的代码业务要进行调整。从之前确定CountDownLatch计数初值变化而来：</li>
</ul>
<pre><code>......
if(index % runwayCount == 0) {
    startingGun =  this.signupPlayers.size() - index &gt; runwayCount?
        new CyclicBarrier(runwayCount):
        new CyclicBarrier(this.signupPlayers.size() - index);
}
......</code></pre>
<p>这里我们就不再赘述代码的工作效果了，因为工作效果不会有任何变化。</p>
<h1>4、后续内容</h1>
<p>下一篇文章开始，我们开始讲解线程间通讯。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 13:51:57 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>线程基础：JDK1.5+（10）——线程新特性（下）的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jmeODM.html" rel="bookmark">Java基础：JDK1&period;5后的新特性：自动拆装箱，以及注意事项</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先来看一段代码: 1 Integer x = new Integer(4); 2 Integer y = 4; 在JDK1.5版本后,以上两行代码都能编译通过,那是因为JDK1.5后加入新特性,自动装箱. 第一句代码是正常的创建对象方法,创建了一个Integer包装类对象. 而第二句中,当左边的Interger类型变量指向右边的int基本类型数据时,右边的基本数据类型会自动装箱成Integer对象,即隐式执行了new Integer(4). 再来一段代码: 1 Integer x = new			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47Rmp93.html" rel="bookmark">Java 9和Java 10的新特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://www.infoq.com/cn/news/2014/09/java9 Java 9新特性汇总 继2014年3月份Java 8发布之后,Open JDK加快了开发速度, Java 9的发布已经提上日程.预计在2016年发布Java 9,同时公布了JEP(JDK改进提议)中的前期列表.任职于Takipi 的Alex Zhitnitsky整理了Java 9中一些纳入JSR(Java规范提案)的新特性和大家一直期待但未确定的一些特性.这些特性有Jigsaw项目.新的智能编译工具.期待已久			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YY8PX0.html" rel="bookmark">ArcGIS 10&period;2新特性介绍：影像</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.新增栅格类型 新增支持三种新的栅格类型:DMCii.Pleiades 和 SPOT6. 同时,新增提供中国卫星 Raster Type 扩展下载,支持中国卫星影像数据在ArcGIS 中的管理和使用.扩展支持的卫星产品包括: HJ 1A/1B CCD raster type ZY02C HRC raster type ZY02C PMS raster type ZY3 – CRESDA ZY3 – SASMAC 对于支持的国产卫星,正射.融合.镶嵌和匀色等常用处理,通过 ArcGIS 的On-			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZA8bg0.html" rel="bookmark">Spark整合kafka0&period;10&period;0新特性&lpar;二&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				接着Spark整合kafka0.10.0新特性(一)开始 import org.apache.kafka.clients.consumer.ConsumerRecord import org.apache.kafka.common.serialization.StringDeserializer import org.apache.spark.streaming.kafka010._ import org.apache.spark.streaming.kafka010.LocationStrat			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M622WNM.html" rel="bookmark">jdk1&period;5出现的新特性----&amp;gt&semi;增强for循环</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				package cn.itcast.jdk15; import java.util.HashMap;import java.util.HashSet;import java.util.Iterator;import java.util.Map;import java.util.Set; /*jdk1.5出现的新特性----&gt;增强for循环 增强for循环的作用: 简化迭代器的书写格式.(注意:增强for循环的底层还是使用了迭代器遍历.) 增强for循环的适用范围: 如果是实现了Iterable接			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6BVEWM.html" rel="bookmark">Java 8中你可能没听过的10个新特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				lambda表达式,lambda表达式,还是lambda表达式.一提到Java 8就只能听到这个,但这不过是其中的一个新功能而已,Java 8还有许多新的特性——有一些功能强大的新类或者新的用法,还有一些功能则是早就应该加到Java里了. 这里我准备介绍它的10个我个人认为非常值得了解的新特性.总会有一款适合你的,开始来看下吧. default方法 这是Java语言的一个新特性,现在接口类里可以包含方法体(这就是default方法)了.这些方法会隐式的添加到实现这个接口的每个子类中. 这使得你可			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MowrjlM.html" rel="bookmark">开发者所需要知道的 iOS 10 SDK 新特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:https://onevcat.com/2016/06/ios-10-sdk/ 写的很好啊.哈哈哈 总览 距离 iPhone 横空出世已经过去了 9 个年头,iOS 的版本号也跨入了两位数.在我们回顾过去四五年 iOS 系统的发展的时候,不免感叹变化速度之快,迭代周期之短.iOS 7 翻天覆地的全新设计,iOS 8 中 Size Classes 的出现,应用扩展,以及 Cloud Kit 的加入,iOS 9 里的分屏多任务特性等等.Apple 近年都是在 WWDC 发布新的系统和软件,然后			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Y9JKw0.html" rel="bookmark">前端面试基础-html篇之H5新特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				h5的新特性(目前个人所了解)如下 语义化标签 表单新特性 视频(video)和音频(audio) canvas画布 svg绘图 地理定位 为鼠标提供的拖放API webworker (重点)Storage (重点)Websocket HTML语义化是什么? 语义化是指根据内容的结构化(内容语义化),选择合适的标签(代码语义化),便于开发者阅读和写出更优雅的代码的同时,让浏览器的爬虫和机器很好的解析. 为什么要语义化? 有利于SEO,有助于爬虫抓取更多的有效信息,爬虫是依赖于标签来确定上下文和各			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xoGjzM.html" rel="bookmark">Red Hat OpenStack 10的新特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这是Red Hat有史以来最好的版本,同时也是第一个长生命周期版本(最长五年支持),这篇文章会介绍为什么这是你私有云最好的礼物. 由于要使用命令行,以前安装OpenStack是很繁重的工作.这个版本提供了一个新的图形界面给Director.这是我们简化OpenStack部署目标的第一步,根据前几个月的内部测试反馈,在将来的版本将会有更多优化. 新的Director图形界面 另一个通过所有测试的新特性是分布虚拟路由(DVR),这个特性虽然功能上还有一些限制,但是已经是生产级别的,同时可以通过Dir			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JpBzl0.html" rel="bookmark">Java基础之JDK1&period;8的接口新特性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Java的JDK1.8中: 1.接口中使用default来修饰普通方法与使用static来修饰普通方法的意义用于避免子类重复实现同样的代码 1 package test; 2 /** 3 * 泛型的使用 4 * @author Administrator 5 * 6 */ 7 public class TestType { 8 9 public static void main(String[] args) { 10 Msg msg = new MsgImpl(); 11 msg.show()			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0nelvM.html" rel="bookmark" class="title">SAP MM模块 常用Bapi</a>
					<div>
						  1.sap货物移动相关的bapi(MIGO/MB1A) 货物移动的bapi  BAPI_GOODSMVT_CREATE 其中 参数 : GOODSMVT_CODE 有 GMCODE Table T ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0xwLjM.html" rel="bookmark" class="title">Interview</a>
					<div>
						下面的题是供大家查漏补缺用的,真正的把这些题搞懂了,才能&quot;以不变应万变&quot;. 回答问题的时候能联系做过项目的例子是最好的,有的问题后面我已经补充联系到项目中的对应的案例了. 1.简述 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/x0dJYZ4.html" rel="bookmark" class="title">C&plus;&plus; Strings&lpar;字符串&rpar;</a>
					<div>
						Constructors 构造函数,用于字符串初始化 Operators 操作符,用于字符串比较和赋值 append() 在字符串的末尾添加文本 assign() 为字符串赋新值 at() 按给定索引 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoQbjl3.html" rel="bookmark" class="title">根据前序序列和中序序列，重建一颗树（PHP递归实现）</a>
					<div>
						class TreeNode{ public $data; public $lchild = null; public $rchild = null; public function __constr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPdYvmM.html" rel="bookmark" class="title">HTML&amp;lt&semi;div&amp;gt&semi;和&amp;lt&semi;span&amp;gt&semi;</a>
					<div>
						可以通过&lt;div&gt;和&lt;span&gt;将HTML元素组合起来 HTML块元素 大多数HTML元素被定义为块级元素&lt;block level element&gt;或内联元素&lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YGNDv4.html" rel="bookmark" class="title">C&num;编程总结（八）数字签名</a>
					<div>
						C#编程总结(八)数字签名 在日常工作中,有很多文件需要领导审阅.签名和盖章,由于公司业务开展,跨地域.跨国业务也日益普遍,领导签名盖章变得很麻烦,开始的时候人们通过邮寄.传真等方式来解决,但是耗费时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49odz10.html" rel="bookmark" class="title">lol&period;py</a>
					<div>
						#!/usr/bin/env python # -*- coding: utf-8 -*- import os from twisted.application import service from ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02D2q24.html" rel="bookmark" class="title">cJSON&lowbar;hacking</a>
					<div>
						1 /****************************************************************************** 2 * cJSON_hacking  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Q8Okw3.html" rel="bookmark" class="title">Linux安装phpredis扩展</a>
					<div>
						Linux下php安装Redis扩展 注意:目录的权限   chomd 777 -R 1.安装redis 下载:https://github.com/nicolasff/phpredis/archiv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXQ7DV0.html" rel="bookmark" class="title">修bug感悟</a>
					<div>
						今天遇到了两个问题: 1. 使用 python 的 PIL 库读取照片的尺寸,对于有些图片,长宽和显示的效果相反,原因是照片中的 exif 有个属性 orientation,表示图片的翻转角度,详细说 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ORrVZ0.html" rel="bookmark" class="title">【卷二】TCP服务器与客户端</a>
					<div>
						经过上回简单地介绍,大家对服务器多少应该清楚一些了吧!还记得TCP: (Transmission Control Protocol) 传输控制协议? 还记得IP: (Internet Protocol ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bpwzm4.html" rel="bookmark" class="title">实战案例：DIV嵌套</a>
					<div>
						缘于页面结构语义化的考虑,我们应该慎用div和span这两个通用元素,只有当划分页面结构模块时才使用div元素,因为模块本身是没有任何语义的,他仅代表一块独立的结构.如果想对段落内部分内联元素或文本应 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j2ZGV0.html" rel="bookmark" class="title">ubuntu安装ssh，安装失败</a>
					<div>
						master@ubuntu :/etc/apt$ sudo apt-get install ssh正在读取软件包列表... 完成正在分析软件包的依赖关系树       正在读取状态信息... 完成   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pNN5w0.html" rel="bookmark" class="title">linux的几个内核镜像格式Image 和 u-boot启动内核和文件系统时的一些环境变量的设置</a>
					<div>
						关于编译powerpc linux的几个Image参考原文 http://blog.sina.com.cn/s/blog_86a30b0c0100wfzt.html 转载▼ PowerPC架构 Lin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzX6qO3.html" rel="bookmark" class="title">北京二手房上周成交环比增六成 个别业主涨价出售</a>
					<div>
						北京二手房上周成交环比增六成 个别业主涨价出售 行业动态北青网-北京青年报范辉2014-10-21 05:23 我要分享 6 [摘要]自9月30日房贷新政发布以来,北京市二手房市场发生了较为明显的变化 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVWrAd0.html" rel="bookmark" class="title">帝国CMS附件大小限制</a>
					<div>
						做文件的上传下载,在我们本地测试总是顺利通过,一上传到服务器各种问题都来了. 帝国CMS,我们先看网站配制中附件大小限制. 附件存放目录设置: 单击菜单&quot;系统&quot;&gt;&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kwWPp0.html" rel="bookmark" class="title">有偻柯寐叟d33dg&fjlig;3cs054e</a>
					<div>
						中国企业改革与发展研究会副会长李锦向记者表示:&quot;员工持股无疑是今年国资改革的重点,也是亮点之一,它是混合所有制改革的一个重要形式和突破口,可以很好的调动员工积极性.&quot; 在不久前落幕 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lLo1o0.html" rel="bookmark" class="title">页面静态化之动态，静态，伪静态概念</a>
					<div>
						页面静态化作为大型网站提速的三大技术之一也是非常重要的,另外还有Memcached和mysql优化技术. 所以,我们应该先对静态,动态,和伪静态的概念要做到了解. 所谓静态:在我个人看来就是单纯的ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dYrA73.html" rel="bookmark" class="title">jquery获取当前元素索引值index&lpar;&rpar;方法（总结）</a>
					<div>
						jquery的index()方法 搜索匹配的元素,并返回相应元素的索引值,从0开始计数. 如果不给 .index() 方法传递参数,那么返回值就是这个jQuery对象集合中第一个元素相对于其同辈元素的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6Vel5M.html" rel="bookmark" class="title">UVALive - 3211 Now or later &lpar;2-SAT&rpar;</a>
					<div>
						题目大意:有n架飞机需要着陆.每架飞机有两种选择,早着陆或者晚着陆,二选其一 现在为了保证飞机的着陆安全,要求两架着陆的飞机的时间间隔的最小值达到最大 解题思路:最小值最大,二分枚举 设第i架飞机选择 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
